/* ccgo: proper.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef PROPER_HH
#define PROPER_HH
#include "sgf/node.hh"
#include "game.hh"
namespace go
{
	class Proper
	{
	public:
		struct Marking
		{
			Loc loc;
			Mark mark;
			Marking(const Loc &, Mark);
		};
	private:
		std::string name;
		std::string comment;
		std::vector<sgf::Prop::Label> labels;
		std::vector<Marking> marks;
	public:
		Proper();
		Proper(const Proper &);
		virtual ~Proper();
		virtual Proper * dup() const;
		virtual void build(const Game &, const sgf::Node &);
		const std::string & get_name() const;
		const std::string & get_comment() const;
		const std::vector<sgf::Prop::Label> & get_labels() const;
		const std::vector<Marking> & get_marking() const;
		std::vector<Marking> & get_marking();
	};
}
#endif // PROPER_HH
